﻿// Copyright 2011 L'Express de Toronto Inc.
// October 26 2011
// Written by Kasyan Servetsky
// http://www.kasyan.ho.com.ua
// e-mail: askoldich@yahoo.com
//==================================================================
app.doScript(SuperFunction, ScriptLanguage.JAVASCRIPT, undefined, UndoModes.FAST_ENTIRE_SCRIPT, "Story Continuation Script");

function SuperFunction() {
	if (app.documents.length == 0) ErrorExit("Please open a document and try again.");

	var gScriptName = "Story Continuation"; // Name of the script
	var gScriptVersion = "2.0"; // Version
	var gDoc = app.activeDocument;
	var gSet = {};

	if (app.selection.length != 1) ErrorExit("One text frame should be selected.");
	if (app.selection[0].constructor.name != "TextFrame") ErrorExit("One text frame should be selected.");
	var gTextFrame =  app.selection[0];
	if (gTextFrame.parentPage.name === "1") ErrorExit("The selected text frame should not be on the first page.");

	var gStory = gTextFrame.parentStory;
	var gTxtFrames = gStory.textContainers;

	var gLastTxtFrames = [];
	var gList = FindHeaders();
	if (gList.length == 0)  ErrorExit("No titles have been found on the front page.");
	CreateDialog(gList);

	//===================================== FUNCTIONS  ======================================
	function Main() {
		var lastPar;
		var lastTxtFrame = gLastTxtFrames[gSet.selectedItem];
		var pageName = gTextFrame.parentPage.name;
		
		if (lastTxtFrame.paragraphs.lastItem().characters.lastItem().contents == "\r") {
			lastTxtFrame.paragraphs.lastItem().characters.lastItem().contents = "";
		}

		lastTxtFrame.insertionPoints[-1].contents = SpecialCharacters.FRAME_BREAK;
		
		if (gTxtFrames.length == 2) {
			SplitFrames();
		}
		lastTxtFrame.nextTextFrame = gTextFrame;

	}
	//--------------------------------------------------------------------------------------------------------------------------------------------------------
	function SplitFrames() {
		var oldTitleFr = gTxtFrames[0];
		var oldBodyFr = gTxtFrames[1];
		
		var newTitleFr = oldTitleFr.duplicate();
		CleanupText(newTitleFr);
		
		gTextFrame = oldBodyFr.duplicate();
		oldTitleFr.remove();
		oldBodyFr.remove();
	}
	//--------------------------------------------------------------------------------------------------------------------------------------------------------
	function FindHeaders() {
		var finds, found;
		var list = [];
		var count = 0;
		app.findGrepPreferences = app.changeGrepPreferences = NothingEnum.nothing;
		app.findGrepPreferences.findWhat = ".+";
		app.findGrepPreferences.appliedParagraphStyle = gDoc.paragraphStyleGroups.item("Titres").paragraphStyles.item("titre.principal");
		finds = gDoc.findGrep();
		
		for (var i = 0; i < finds.length; i++) {
			found = finds[i];
			if (found.parentTextFrames[0].parentPage.name === "1") {
				if (found.parentStory.textContainers.length < 3) {
					count++;			
					//$.writeln( count + " - " + found.contents );
					list.push(found.contents);
					gLastTxtFrames.push(found.parentStory.textContainers[found.parentStory.textContainers.length-1]);
				}
			}
		}

		return list;
	}
	//--------------------------------------------------------------------------------------------------------------------------------------------------------
	function ErrorExit(error, icon) {
		alert(error, gScriptName + " - " + gScriptVersion, icon);
		exit();
	}
	//--------------------------------------------------------------------------------------------------------------------------------------------------------
	function CreateDialog(list) {
		var win = new Window("dialog", gScriptName + " - " + gScriptVersion);
		win.panel = win.add("panel", undefined, "");	
		// Drop down list
		win.panel.ddl = win.panel.add("dropdownlist", undefined, list);
		win.panel.ddl.alignment = "left";
		win.panel.ddl.selection = 0;

		// Buttons
		win.buttons = win.add("group");
		win.buttons.orientation = "row";   
		win.buttons.alignment = "center";
		win.buttons.ok = win.buttons.add("button", undefined, "OK", {name:"ok" });
		win.buttons.cancel = win.buttons.add("button", undefined, "Cancel", {name:"cancel"});
		
		var showDialog = win.show();
		
		if (showDialog == 1) {
			gSet.selectedItem = win.panel.ddl.selection.index;
			Main();
		}
	}
	//--------------------------------------------------------------------------------------------------------------------------------------------------------
	function FitFrame(txtFrame) {
		var gb = txtFrame.geometricBounds;
		while (txtFrame.overflows) {
			gb[2] = gb[2] + 0.1;
			txtFrame.geometricBounds = gb;
		}
	}
	//--------------------------------------------------------------------------------------------------------------------------------------------------------
	function CleanupText(txtObj) {
		// remove (return and) frame break
		app.findGrepPreferences = app.changeGrepPreferences = NothingEnum.NOTHING;
		app.findGrepPreferences.findWhat = "(~R|\\r~R)";
		app.changeGrepPreferences.changeTo = "";
		txtObj.changeGrep();
		app.findGrepPreferences = app.changeGrepPreferences = NothingEnum.NOTHING;
	}
}